<?php

// $Id:

require_once (drupal_get_path('module', 'reference_links') . '/reference_links.inc');

/**
 * take control admin configuration form.
 */
function reference_links_settings_form(&$form_state = array()) {
  $types = node_get_types();
  $options = array();
  $defaults = array();
  foreach ($types as $type => $info) {
    $options[$type] = $info->name;
    if (variable_get('reference_links_types_' . $type, TRUE)) {
      $defaults[] = $type;
    }
  }

  $form['reference_links_display_types'] = array(
      '#type' => 'checkboxes',
      '#title' => t('Content types'),
      '#options' => $options,
      '#default_value' => $defaults,
      '#description' => t('Choose which content types to display the Reference Links on.'));

  $form['reference_links_collapsed'] = array(
      '#type' => 'checkbox',
      '#title' => t('Display Collpased'),
      '#default_value' => variable_get('reference_links_collapsed', FALSE),
      '#description' => t('True to display the Reference links collapsed, false otherwise.'));

  $form['reference_links_teasers'] = array(
      '#type' => 'checkbox',
      '#title' => t('Show Links on teasers'),
      '#default_value' => variable_get('reference_links_teasers', FALSE),
      '#description' => t('If checked, the Reference Links will appear on teasers in lists of nodes'));

  $form['reference_links_extjs_ver'] = array(
      '#type' => 'select',
      '#options' => drupal_map_assoc(reference_links_extjs_dirs()),
      '#default_value' => variable_get('reference_links_extjs_ver', ''),
      '#required' => TRUE,
      '#title' => t('ExtJs version directory'),
      '#description' => t('ExtJs version directory (in /sites/all/libraries) that should be used by the Reference Links module.'));

  $form['#submit'][] = 'reference_links_settings_submit_handler';

  return system_settings_form($form);
}

/**
 * Custom submit handler to process custom form data.
 */
function reference_links_settings_submit_handler($form, &$form_state) {
  $types = node_get_types();
  foreach ($types as $type => $info) {
    if (!empty($form_state['values']['reference_links_display_types'][$type])) {
      variable_set('reference_links_types_' . $type, TRUE);
    }
    else {
      variable_set('reference_links_types_' . $type, FALSE);
    }
  }

  variable_set('reference_links_collapsed', $form_state['values']['reference_links_collapsed']);
  variable_set('reference_links_teasers', $form_state['values']['reference_links_teasers']);
  variable_set('reference_links_extjs_ver', $form_state['values']['reference_links_extjs_ver']);
}
