<?php

// $Id:


function reference_links_node_links($nid) {
  $result = db_query('SELECT * FROM {reference_links} WHERE nid = %d', $nid);
  $links = array();
  while ($link = db_fetch_object($result)) {
    $links[] = array(
        'lid' => $link->lid,
        'url' => $link->url,
        'title' => $link->title,
        'target' => $link->target,
        'rating' => reference_links_get_score($link->lid));
  }

  usort($links, "reference_links_link_comparer");

  return ($links);
}

function reference_links_link_comparer($a, $b) {
  return ($b['rating'] - $a['rating']);
}

function reference_links_app_dir() {
  return (dirname($_SERVER['SCRIPT_FILENAME']));
}

function reference_links_base_extjs_dir() {
  return (reference_links_app_dir() . str_replace('/', DIRECTORY_SEPARATOR, '/sites/all/libraries/extjs'));
}

function reference_links_extjs_dirs() {
  $extvers = array();
  $basedir = reference_links_base_extjs_dir();
  foreach (scandir($basedir) as $item) {
    if ($item == '.' || $item == '..')
      continue;
    if (is_dir($basedir . DIRECTORY_SEPARATOR . $item)) {
      $extvers[] = $item;
    }
  }

  return ($extvers);
}

function reference_links_ext_path() {
  $extdir = variable_get('reference_links_extjs_ver', NULL);
  if (is_null($extdir)) {
    $dirs = reference_links_extjs_dirs();
    $extdir = $dirs[0];
  }
  return ('sites/all/libraries/extjs/' . $extdir);
}

function reference_links_get_score($lid) {
  $criteria['content_id'] = $lid;
  $criteria['content_type'] = 'reference_links';
  $criteria['value_type'] = 'points';
  $criteria['function'] = 'average';
  $results = votingapi_select_results($criteria);
  if (empty($results)) {
    return 0;
  }
  else {
    return $results[0]['value'];
  }
}

function reference_links_get_votes($lid, $uid) {
  $criteria['content_id'] = $lid;
  $criteria['value_type'] = 'points';
  if ($uid == 0) {
    $criteria['vote_source'] = ip_address();
  }
  else {
    $criteria['uid'] = $uid;
  }
  $results = votingapi_select_votes($criteria);
  return count($results);
}

